.386

.MODEL FLAT, STDCALL

OPTION CASEMAP:NONE

INCLUDE    \masm32\include\windows.inc
INCLUDE    \masm32\include\kernel32.inc
INCLUDE    \masm32\include\comdlg32.inc
INCLUDE    \masm32\include\user32.inc
INCLUDELIB \masm32\lib\kernel32.lib
INCLUDELIB \masm32\lib\comdlg32.lib
INCLUDELIB \masm32\lib\user32.lib

.DATA

AppName      DB "Przykad nr 1 testowania Win32", 0
ofn          OPENFILENAME <>
FilterString DB "Pliki wykonywalne", 0, "*.exe", 0,
                "Wszystkie pliki", 0, "*.*", 0, 0
ExitProc     DB "Program testowany koczy dziaanie", 0       
NewThread    DB "Tworzony jest nowy wtek", 0
EndThread    DB "Usuwany jest wtek", 0
ProcessInfo  DB "Uchwyt pliku: %lx ", 0dh, 0Ah,
                "Uchwyt procesu: %lx", 0Dh, 0Ah,
                "Uchwyt wtku: %lx", 0Dh, 0Ah,
                "Podstawa obrazu: %lx", 0Dh, 0Ah,
                "Adres startowy: %lx", 0

.DATA?

buffer    DB 512 DUP(?)
startinfo STARTUPINFO <>
pi        PROCESS_INFORMATION <>
DBEvent   DEBUG_EVENT <>

.CODE

start:
    mov    ofn.lStructSize, SIZEOF ofn
    mov    ofn.lpstrFilter, OFFSET FilterString
    mov    ofn.lpstrFile, OFFSET buffer
    mov    ofn.nMaxFile, 512
    mov    ofn.Flags, OFN_FILEMUSTEXIST OR OFN_PATHMUSTEXIST OR \
                      OFN_LONGNAMES OR OFN_EXPLORER OR OFN_HIDEREADONLY
    INVOKE GetOpenFileName, ADDR ofn
    .IF eax==TRUE
        INVOKE GetStartupInfo, ADDR startinfo
        INVOKE CreateProcess, ADDR buffer, NULL, NULL, NULL, FALSE,
                              DEBUG_PROCESS + DEBUG_ONLY_THIS_PROCESS,
                              NULL, NULL, ADDR startinfo, ADDR pi
        .WHILE TRUE
            INVOKE WaitForDebugEvent, ADDR DBEvent, INFINITE
            .IF DBEvent.dwDebugEventCode==EXIT_PROCESS_DEBUG_EVENT
                INVOKE MessageBox, 0, ADDR ExitProc, ADDR AppName,
                                   MB_OK + MB_ICONINFORMATION
                .BREAK
            .ELSEIF DBEvent.dwDebugEventCode==CREATE_PROCESS_DEBUG_EVENT
                INVOKE wsprintf, ADDR buffer, ADDR ProcessInfo,
                                 DBEvent.u.CreateProcessInfo.hFile,
                                 DBEvent.u.CreateProcessInfo.hProcess,
                                 DBEvent.u.CreateProcessInfo.hThread,
                                 DBEvent.u.CreateProcessInfo.lpBaseOfImage,
                                 DBEvent.u.CreateProcessInfo.lpStartAddress
                INVOKE MessageBox, 0, ADDR buffer, ADDR AppName,
                                   MB_OK + MB_ICONINFORMATION
            .ELSEIF DBEvent.dwDebugEventCode==EXCEPTION_DEBUG_EVENT
                .IF DBEvent.u.Exception.pExceptionRecord.ExceptionCode==\
                    EXCEPTION_BREAKPOINT
                    INVOKE ContinueDebugEvent, DBEvent.dwProcessId,
                                               DBEvent.dwThreadId,
                                               DBG_CONTINUE    
                    .CONTINUE
                .ENDIF
            .ELSEIF DBEvent.dwDebugEventCode==CREATE_THREAD_DEBUG_EVENT
                INVOKE MessageBox, 0, ADDR NewThread, ADDR AppName,
                                   MB_OK + MB_ICONINFORMATION            
            .ELSEIF DBEvent.dwDebugEventCode==EXIT_THREAD_DEBUG_EVENT
                INVOKE MessageBox, 0, ADDR EndThread, ADDR AppName,
                                   MB_OK + MB_ICONINFORMATION            
            .ENDIF
            INVOKE ContinueDebugEvent, DBEvent.dwProcessId,
                                       DBEvent.dwThreadId,
                                       DBG_EXCEPTION_NOT_HANDLED
        .ENDW
    .ENDIF
    INVOKE CloseHandle, pi.hProcess
    INVOKE CloseHandle, pi.hThread
    INVOKE ExitProcess, 0

END start
